DAT programName         byte "DemoFourMotorsSimple130205c", 0     
CON
{{
  ******* Public Notes *******

  Program written by Duane Degn
  See date code in file name for last update.
  (Example: 130205x indicates the last update
  was on February 5, 2013.)
  
  The motor control object is based on a two motor
  control object written by Hanno and includes his
  copyright notice.
  
  See child object for additional credit information.
  
  Program to demonstrate the use of motor driver.

  This is a very basic demo.
  See "DemoFourMotorsAndEncoders130205ba" for a more
  comprehensive demo.
  
  To make it easy to use this program with multiple
  robots, I've moved pin assignments to a header
  file.
  The header file also includes other robot specific
  data. Much of the header file information is not
  used in this demo.

  
 
  
}}
{
  ******* Private Notes *******

  130125a Use debug statements in parent object
  instead of child object.
  DemoFourMotorsAndEncoders130125a modified from
  DemoFourMotors130125a.
  DemoFourMotorsAndEncoders130125a add encoders.
  31c Comment out motor control.
  0201a Switch to Vex Treads robot.
  0203a Progress! Motor #0 at +1000 target speeds reads
  -945 speed from encoders.
  05ba Fork version 130203b Cleanup older version to post
  to forum. Add more comments.
  DemoFourMotorsSimple130205a modified from
  DemoFourMotorsAndEncoders130205ba.
  130205a Strip demo down to very basics.
  
} 
  _CLKMODE = XTAL1 + PLL16X 
  _XINFREQ = 5_000_000
  
  MAXSPEED = 5000
    
 
  MOTORS_IN_USE = 4


VAR

  long enablePin[MOTORS_IN_USE], motorPinRed[MOTORS_IN_USE], motorPinBlack[MOTORS_IN_USE]
    
OBJ

  Pwm : "fourMotorsOneCog130205a"                       ' Uses one cog
  Header : "HeaderVexTreads130201a"                     
  'Header : "HeaderRover5_130130a"
  
PUB Setup
  
  enablePin[0] := Header#WHEEL_ENABLE_0
  motorPinRed[0] := Header#WHEEL_RED_0
  motorPinBlack[0] := Header#WHEEL_BLACK_0
  enablePin[1] := Header#WHEEL_ENABLE_1
  motorPinRed[1] := Header#WHEEL_RED_1 
  motorPinBlack[1] := Header#WHEEL_BLACK_1 
  enablePin[2] := Header#WHEEL_ENABLE_2
  motorPinRed[2] := Header#WHEEL_RED_2
  motorPinBlack[2] := Header#WHEEL_BLACK_2
  enablePin[3] := Header#WHEEL_ENABLE_3
  motorPinRed[3] := Header#WHEEL_RED_3 
  motorPinBlack[3] := Header#WHEEL_BLACK_3 

  Pwm.Start(motorPinRed[0], motorPinRed[1], motorPinRed[2], motorPinRed[3], {
  } motorPinBlack[0], motorPinBlack[1], motorPinBlack[2], motorPinBlack[3], {
  } enablePin[0], enablePin[1], enablePin[2], enablePin[3])

  MainLoop

PUB MainLoop  
'' All motors drive forward, stop, drive backward, stop and repeat.

  repeat 
    waitcnt(clkfreq + cnt)
    Pwm.Update(600, 600, 600, 600)
    waitcnt(clkfreq + cnt)
    Pwm.Update(1000, 1000, 1000, 1000)
    waitcnt(clkfreq + cnt)
    Pwm.Update(600, 600, 600, 600)
    waitcnt(clkfreq + cnt)
    Pwm.Update(0, 0, 0, 0)
    waitcnt(clkfreq + cnt)
    Pwm.Update(-600, -600, -600, -600)
    waitcnt(clkfreq + cnt)
    Pwm.Update(-1000, -1000, -1000, -1000)
    waitcnt(clkfreq + cnt)
    Pwm.Update(-600, -600, -600, -600)
    waitcnt(clkfreq + cnt)
    Pwm.Update(0, 0, 0, 0)

DAT '' License
{{
*********************************************************************************************
*                             TERMS OF USE: MIT License                                     *                                                                   
*********************************************************************************************
* Permission is hereby granted, free of charge, to any person obtaining a copy of this      *
* software and associated documentation files (the "Software"), to deal in the Software     *
* without restriction, including without limitation the rights to use, copy, modify,        *
* merge, publish, distribute, sublicense, and/or sell copies of the Software, and to        *
* permit persons to whom the Software is furnished to do so, subject to the following       *
* conditions:                                                                               *
*                                                                                           *                                    
* The above copyright notice and this permission notice shall be included in all copies or  *
* substantial portions of the Software.                                                     *
*                                                                                           *                                   
* The software is provided "as is", without warranty of any kind, express or implied,       *
* including but not limited to the warranties of merchantability, fitness for a particular  *
* and noninfringment. In no event shall the authors or copyright holders be liable for any  *
* claim, damages or other liability, whether in an action of contract, tort or otherwise,   *
* arising from, of or in connection with the software of the use of other dealings in the   *
* software.                                                                                 *
*********************************************************************************************
}}            